Package: lorentz
Type: Package
Title: The Lorentz Transform in Relativistic Physics
Version: 1.1-2
Authors@R: person(given=c("Robin", "K. S."), family="Hankin", role = c("aut","cre"), email="hankin.robin@gmail.com", comment = c(ORCID = "0000-0001-5982-0415"))
Suggests: knitr,testthat,rmarkdown,covr
Imports: quadform,tensor,magic,magrittr
Maintainer: Robin K. S. Hankin <hankin.robin@gmail.com>
Depends: R (>= 4.1.0)
Description: The Lorentz transform in special relativity; also the
    gyrogroup structure of three-velocities.  Performs active and
    passive transforms and has the ability to use units in which the
    speed of light is not unity.  Includes some experimental
    functionality for celerity and rapidity.  For general relativity,
    see the 'schwarzschild' package.
License: GPL-3
Encoding: UTF-8
VignetteBuilder: knitr
URL: https://github.com/RobinHankin/lorentz,
        https://robinhankin.github.io/lorentz/
BugReports: https://github.com/RobinHankin/lorentz/issues
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2025-01-22 11:42:42 UTC; rhankin
Author: Robin K. S. Hankin [aut, cre] (<https://orcid.org/0000-0001-5982-0415>)
Repository: CRAN
Date/Publication: 2025-01-23 16:20:01 UTC
Built: R 4.6.0; ; 2026-04-26 21:24:17 UTC; unix

exportPattern("^[[:alpha:]]+")
exportPattern("4vel")

importFrom("stats", "runif", "rnorm")
importFrom("quadform","quad.tdiag","quad.tform", "quad.form","quad3.form", "quad3.tdiag")
importFrom("graphics", "arrows", "legend", "plot", "points")
importFrom("magic","adiag")
importFrom("magrittr", "%>%")

importFrom("tensor","tensor")
importFrom("utils","capture.output")
           

S3method("Ops"    , "3vel")
S3method("Ops"    , "4vel")
S3method("Ops"    , "4mom")
S3method("length" ,  "vec")
S3method("names"  ,  "vec")
S3method("names<-",  "vec")
S3method("print"  , "3vel")
S3method("print"  , "3cel")
S3method("print"  , "4vel")
S3method("print"  , "4mom")
S3method("["      ,  "vec")
S3method("[<-"    , "3vel")
S3method("[<-"    , "4vel")
S3method("gam"    , "3vel")
S3method("gam"    , "3cel")
S3method("gam"    , "4vel")
S3method("gamm1"  , "3vel")
S3method("gamm1"  , "4vel")
S3method("c"      , "3vel")
S3method("c"      , "3cel")
S3method("c"      , "4vel")
S3method("speed"  , "3vel")
S3method("speed"  , "4vel")

S3method("rapidity", "3vel")
S3method("rapidity", "4vel")
S3method("rapidity", "default")

S3method("celerity", "3vel")
S3method("celerity", "4vel")
S3method("celerity", "default")

S3method("as.matrix", "3vel")
S3method("as.matrix", "4vel")

S3method("gam"    , "default")
S3method("gamm1"  , "default")
         
S3method("seq", "3vel")
S3method("sum", "4mom")

File lorentz_arxiv.Rnw is basically the same as the vignette
(vignettes/lorentz.Rmd) but modified for arxiv.  The bib file is a
modified version of vignettes/lorentz.bib, now under version control.
There might be a better way to do this.

Weave  'lorentz_arxiv.Rnw' with something like

R CMD Sweave lorentz_arxiv.Rnw

(that takes about five minutes).  This will create lorentz_arxiv.tex.

To latex lorentz_arxiv.tex, you will need a couple of auxiliary files:

* arxiv.sty from https://github.com/kourgeorge/arxiv-style
* orcid.png, from https://orcid.org/signin
* lorentz.png, the hexsticker, copied from man/figures

Then 

pdflatex lorentz_arxiv
bibtex lorentz_arxiv
pdflatex lorentz_arxiv
pdflatex lorentz_arxiv

will create lorentz_arxiv.pdf and lorentz_arxiv.bbl

These files will have to be uploaded to arxiv for it to process
lorentz_arxiv.tex; remember to upload lorentz_arxiv.bbl as well.

NOTES

- The tex file, lorentz_arxiv.tex, is NOT under version control.
- Recent work on the lorentz R package means that processing
     lorentz_arxiv.Rnw requires the magrittr package

The lorentz package: special relativity in R
================

<!-- README.md is generated from README.Rmd. Please edit that file -->
<!-- badges: start -->

[![R-CMD-check](https://github.com/RobinHankin/lorentz/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/RobinHankin/lorentz/actions/workflows/R-CMD-check.yaml)
[![Rdoc](https://www.rdocumentation.org/badges/version/lorentz)](https://www.rdocumentation.org/packages/lorentz)
[![Codecov test
coverage](https://app.codecov.io/gh/RobinHankin/lorentz/branch/master/graph/badge.svg)](https://app.codecov.io/gh/RobinHankin/lorentz/branch/master)
<!-- badges: end -->

# Overview

<img src="../../R/x86_64-pc-linux-gnu-library/4.4/lorentz/help/figures/lorentz.png" width="20%" style="float:right; padding:10px" />

The `lorentz` package furnishes some R-centric functionality for special
relativity. Lorentz transformations of four-vectors are handled and some
functionality for the stress energy tensor is given. The package deals
with four-momentum and has facilities for dealing with photons and
mirrors in relativistic situations. A detailed vignette is provided in
the package.

The original motivation for the package was the investigation of the
(nonassociative) gyrogroup structure of relativistic three-velocities
under Einsteinian velocity composition. Natural R idiom may be used to
manipulate vectors of three-velocities, although one must be careful
with brackets.

# Installation

To install the most recent stable version on CRAN, use
`install.packages()` at the R prompt:

    R> install.packages("lorentz")

To install the current development version use `devtools`:

    R> devtools::install_github("RobinHankin/lorentz")

And then to load the package use `library()`:

``` r
library("lorentz")
```

# The `lorentz` package in use

The package furnishes natural R idiom for working with three-velocities,
four-velocities, and Lorentz transformations as four-by-four matrices.
Although natural units in which
![c=1](https://latex.codecogs.com/png.latex?c%3D1 "c=1") are used by
default, this can be changed.

``` r
 u <- as.3vel(c(0.6,0,0))  # define a three-velocity, 0.6c to the right
 u
#> A vector of three-velocities (speed of light = 1)
#>        x y z
#> [1,] 0.6 0 0

as.4vel(u)    # convert to a four-velocity:
#> A vector of four-velocities (speed of light = 1)
#>         t    x y z
#> [1,] 1.25 0.75 0 0
gam(u)  # calculate the gamma term
#> [1] 1.25

B <- boost(u) # give the Lorentz transformation
B
#>       t     x y z
#> t  1.25 -0.75 0 0
#> x -0.75  1.25 0 0
#> y  0.00  0.00 1 0
#> z  0.00  0.00 0 1
```

The boost matrix can be used to transform arbitrary four-vectors:

``` r
B %*% (1:4)  # Lorentz transform of an arbitrary four-vector
#>    [,1]
#> t -0.25
#> x  1.75
#> y  3.00
#> z  4.00
```

But it can also be used to transform four-velocities:

``` r
v <- as.4vel(c(0,0.7,-0.2))
B %*% t(v)
#>        [,1]
#> t  1.823312
#> x -1.093987
#> y  1.021055
#> z -0.291730
```

The classical parallelogram law for addition of velocities is incorrect
when relativistic effects are included. To combine
![u](https://latex.codecogs.com/png.latex?u "u") and
![v](https://latex.codecogs.com/png.latex?v "v") in terms of successive
boosts we would simply multiply the boost matrices:

``` r
boost(u) %*% boost(v)
#>           t     x          y          z
#> t  1.823312 -0.75 -1.2763187  0.3646625
#> x -1.093987  1.25  0.7657912 -0.2187975
#> y -1.021055  0.00  1.4240348 -0.1211528
#> z  0.291730  0.00 -0.1211528  1.0346151
```

and note that the result depends on the order:

``` r
boost(v) %*% boost(u)
#>            t          x          y          z
#> t  1.8233124 -1.0939874 -1.0210549  0.2917300
#> x -0.7500000  1.2500000  0.0000000  0.0000000
#> y -1.2763187  0.7657912  1.4240348 -0.1211528
#> z  0.3646625 -0.2187975 -0.1211528  1.0346151
```

# Vectorization

The package is fully vectorized and can deal with vectors whose entries
are three-velocities or four-velocities:

``` r
 set.seed(0)
 options(digits=3)
 # generate 5 random three-velocities:
 (u <- r3vel(5))
#> A vector of three-velocities (speed of light = 1)
#>           x       y      z
#> [1,]  0.230  0.0719  0.314
#> [2,] -0.311  0.4189 -0.277
#> [3,] -0.185  0.5099 -0.143
#> [4,] -0.739 -0.4641  0.129
#> [5,] -0.304 -0.2890  0.593
 # calculate the gamma correction term:
 gam(u)
#> [1] 1.09 1.24 1.21 2.13 1.46

 # add a velocity of 0.9c in the x-direction:
 v <- as.3vel(c(0.9,0,0))
 v+u
#> A vector of three-velocities (speed of light = 1)
#>          x      y      z
#> [1,] 0.936  0.026  0.113
#> [2,] 0.818  0.253 -0.168
#> [3,] 0.858  0.267 -0.075
#> [4,] 0.480 -0.605  0.168
#> [5,] 0.820 -0.174  0.356


 # convert u to a four-velocity:
 as.4vel(u)
#> A vector of four-velocities (speed of light = 1)
#>         t      x       y      z
#> [1,] 1.09  0.250  0.0783  0.341
#> [2,] 1.24 -0.385  0.5190 -0.343
#> [3,] 1.21 -0.223  0.6160 -0.173
#> [4,] 2.13 -1.571 -0.9862  0.273
#> [5,] 1.46 -0.443 -0.4209  0.864

 # use four-velocities to effect the same transformation:
 w <- as.4vel(u) %*% boost(-v)
 as.3vel(w)
#> A vector of three-velocities (speed of light = 1)
#>          x      y      z
#> [1,] 0.936  0.026  0.113
#> [2,] 0.818  0.253 -0.168
#> [3,] 0.858  0.267 -0.075
#> [4,] 0.480 -0.605  0.168
#> [5,] 0.820 -0.174  0.356
```

# Three-velocities

Three-velocities behave in interesting and counter-intuitive ways.

``` r
 u <- as.3vel(c(0.2,0.4,0.1))   # single three-velocity
 v <- r3vel(4,0.9)              # 4 random three-velocities with speed 0.9
 w <- as.3vel(c(-0.5,0.1,0.3))  # single three-velocity
```

The three-velocity addition law is given by Ungar.

Then we can see that velocity addition is not commutative:

``` r
 u+v
#> A vector of three-velocities (speed of light = 1)
#>           x      y     z
#> [1,]  0.702 -0.113 0.567
#> [2,] -0.679  0.580 0.102
#> [3,] -0.046  0.879 0.364
#> [4,]  0.312  0.407 0.788
 v+u
#> A vector of three-velocities (speed of light = 1)
#>           x      y     z
#> [1,]  0.624 -0.378 0.543
#> [2,] -0.823  0.358 0.045
#> [3,] -0.234  0.832 0.401
#> [4,]  0.228  0.190 0.892
 (u+v)-(v+u)
#> A vector of three-velocities (speed of light = 1)
#>          x     y       z
#> [1,] 0.243 0.506  0.1190
#> [2,] 0.201 0.490  0.1206
#> [3,] 0.503 0.245 -0.0519
#> [4,] 0.242 0.564 -0.1105
```

Observe that the difference between `u+v` and `v+u` is not “small” in
any sense. Commutativity is replaced with gyrocommutatitivity:

``` r
# Compare two different ways of calculating the same thing:
 (u+v) - gyr(u,v,v+u)  
#> A vector of three-velocities (speed of light = 1)
#>              x         y         z
#> [1,]  3.53e-15 -1.20e-15  2.89e-15
#> [2,]  2.89e-16 -3.18e-15 -1.08e-16
#> [3,] -4.26e-15  1.09e-13  4.67e-14
#> [4,]  1.67e-15  4.76e-16  1.91e-15

# The other way round:
 (v+u) - gyr(v,u,u+v)
#> A vector of three-velocities (speed of light = 1)
#>             x         y         z
#> [1,] 3.21e-15 -6.42e-16  2.89e-15
#> [2,] 3.76e-15 -1.73e-15 -2.53e-16
#> [3,] 1.47e-14 -4.07e-14 -2.03e-14
#> [4,] 9.05e-15  6.43e-15  3.24e-14
```

(that is, zero to numerical accuracy)

## Nonassociativity of three-velocities

It would be reasonable to expect that `u+(v+w)==(u+v)+w`. However, this
is not the case:

``` r
 ((u+v)+w) - (u+(v+w))
#> A vector of three-velocities (speed of light = 1)
#>             x       y         z
#> [1,]  0.00613  0.0794 -0.001467
#> [2,] -0.11096 -0.1508 -0.031226
#> [3,] -0.10748 -0.1022  0.000795
#> [4,] -0.05772 -0.0631 -0.007364
```

(that is, significant departure from associativity). Associativity is
replaced with gyroassociativity:

``` r
 (u+(v+w)) - ((u+v)+gyr(u,v,w))
#> A vector of three-velocities (speed of light = 1)
#>      x         y         z
#> [1,] 0  8.16e-17 -6.53e-16
#> [2,] 0 -9.49e-16  0.00e+00
#> [3,] 0  3.21e-15  1.60e-15
#> [4,] 0  0.00e+00  0.00e+00
 ((u+v)+w) - (u+(v+gyr(v,u,w)))
#> A vector of three-velocities (speed of light = 1)
#>              x         y         z
#> [1,]  0.00e+00  4.03e-17 -1.29e-15
#> [2,] -1.81e-15  9.07e-16  0.00e+00
#> [3,]  0.00e+00  1.37e-14  5.48e-15
#> [4,]  0.00e+00 -1.84e-15 -1.84e-15
```

(zero to numerical accuracy).

# References

The most concise reference is

- A. A. Ungar 2006. *Thomas precession: a kinematic effect of the
  algebra of Einstein’s velocity addition law. Comments on “Deriving
  relativistic momentum and energy: II, Three-dimensional case*.
  European Journal of Physics, 27:L17-L20

# Further information

For more detail, see the package vignette

    vignette("lorentz")

## This is a systematic attempt to find a distributive law for
## three-velocities: r*(u+v) = <some function of u,v,r>.

## Here, u and v are three-velocities and r is a real number.

## In this script, function possible() defines a large number of
## possible combinations of u, v, and r.  These are calculated at the
## end of the script and the results compared with the exact value.
## If there is an exact expression, this will have zero badness.

## I have tried to enumerate the various combinations of u,v,r.  Signs
## are permuted in every_sign() and all3() and all3brack().  Just
## execute the script and if one of the many combinations (688128, as
## of 26/1/2018) represents the RHS of a putative distributive law,
## the corresponding element of variable 'badness', defined at the end
## of this script, will be zero.  I have not found one yet.

## Function possible() returns a long vector of possible expressions
## that might form the RHS for a distributive law.  The basic idea is
## that r*(u+v) = ru+rv + <some correction> but because of
## noncommutativity and nonassociativity, this gets complicated.

## Function possible() returns a vector that includes things like

## ru  + (rv  - r*gyr[ru, v,u+v])
## ru  + (rv  - r*gyr[ru, v,v+u])
## rv  + (ru  - r*gyr[su, v,u+v])
## (ru + rv)  + r*gyr[ru, v,u])
## (ru + rv)  + r*gyr[ru, v,v])
## (ru + rv)  + r*gyr[ru, v,v])
## (ru + rv)  + r*gyr[ru,-v,v])
## (ru + rv)  +   gyr[ru,-v,v])
## (ru + rv)  + s*gyr[ru,-v,v])

## etc etc etc.  Here, r is a scalar, s=1/r, and u,v are
## three-velocities.  Note the variety of orders (three-velocity
## addition is not commutative), different bracketing (three-velocity
## addition is not associative), and use of r or 1/r in differnt
## places in the formula.


library("lorentz")
library("partitions")

u <- r3vel(1,0.4)
v <- r3vel(1,0.5)
r <- 2

`possible` <- function(u,v,r){ 
 # In function possible(), u,v are three-velocities and r is a real
 # number.  Function possible() returns a vector of 64*10752=688128
 # three-velocities [the '64' is from combinations of r, 1/r as in jj
 # below; the 10752 is from function f(), defined inside possible()]

  f <- function(r1,r2,r3){  
    ##  In function f(), r1,r2,r3 are real numbers; function f() has
    ##  4*14 = 56 lines, so returns 56*192=10752 three-velocities.

    ## NB: Inside f(), r,u,v come from possible()'s scope
    c(
        every_sign(r*u,r*v, r1*u     ,r2*v  , u+v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v  , v+u,r3),
        every_sign(r*u,r*v, r1*v     ,r2*u  , u+v,r3),
        every_sign(r*u,r*v, r1*v     ,r2*u  , v+u,r3),

        every_sign(r*u,r*v, r1*u     ,r2*v  , u-v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v  , v-u,r3),
        every_sign(r*u,r*v, r1*v     ,r2*u  , u-v,r3),
        every_sign(r*u,r*v, r1*v     ,r2*u  , v-u,r3),
        
        every_sign(r*u,r*v, r1*u     ,r2*v+u, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v+u, v+u,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u+v, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u+v, v+u,r3),

        every_sign(r*u,r*v, r1*u     ,r2*v-u, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v-u, v+u,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u-v, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u-v, v+u,r3),

        every_sign(r*u,r*v, r1*u     ,r2*v+u, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v+u, v-u,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u+v, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u+v, v-u,r3),
        
        every_sign(r*u,r*v, r1*u     ,r2*v-u, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*v-u, v-u,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u-v, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,r2*u-v, v-u,r3),

        
        every_sign(r*u,r*v, r1*u     ,v+r2*u, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,v+r2*u, v+u,r3),
        every_sign(r*u,r*v, r1*u     ,u+r2*v, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,u+r2*v, v+u,r3),
        
        every_sign(r*u,r*v, r1*u     ,v+r2*u, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,v+r2*u, v-u,r3),
        every_sign(r*u,r*v, r1*u     ,u+r2*v, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,u+r2*v, v-u,r3),
        
        every_sign(r*u,r*v, r1*u     ,v-r2*u, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,v-r2*u, v+u,r3),
        every_sign(r*u,r*v, r1*u     ,u-r2*v, u+v,r3),
        every_sign(r*u,r*v, r1*u     ,u-r2*v, v+u,r3),
        
        every_sign(r*u,r*v, r1*u     ,v-r2*u, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,v-r2*u, v-u,r3),
        every_sign(r*u,r*v, r1*u     ,u-r2*v, u-v,r3),
        every_sign(r*u,r*v, r1*u     ,u-r2*v, v-u,r3),
        
        every_sign(r*u,r*v, r1*u+r2*v,v     , u+v,r3),
        every_sign(r*u,r*v, r1*u+r2*v,v     , v+u,r3),
        every_sign(r*u,r*v, r1*v+r2*u,u     , u+v,r3),
        every_sign(r*u,r*v, r1*v+r2*u,u     , v+u,r3),
        
        every_sign(r*u,r*v, r1*u+r2*v,v     , u-v,r3),
        every_sign(r*u,r*v, r1*u+r2*v,v     , v-u,r3),
        every_sign(r*u,r*v, r1*v+r2*u,u     , u-v,r3),
        every_sign(r*u,r*v, r1*v+r2*u,u     , v-u,r3),
        
        every_sign(r*u,r*v, r1*u-r2*v,v     , u+v,r3),
        every_sign(r*u,r*v, r1*u-r2*v,v     , v+u,r3),
        every_sign(r*u,r*v, r1*v-r2*u,u     , u+v,r3),
        every_sign(r*u,r*v, r1*v-r2*u,u     , v+u,r3),
        
        every_sign(r*u,r*v, r1*u-r2*v,v     , u-v,r3),
        every_sign(r*u,r*v, r1*u-r2*v,v     , v-u,r3),
        every_sign(r*u,r*v, r1*v-r2*u,u     , u-v,r3),
        every_sign(r*u,r*v, r1*v-r2*u,u     , v-u,r3)

    )
  }

  jj <- c(r,1,1/r,0)
  jj <- as.matrix(expand.grid(jj,jj,jj))
  ## jj has 4^3=64 rows
  out <- u
  for(i in seq_len(nrow(jj))){
    cat(paste(i," / ",nrow(jj),"\n",sep=""))
    out <- c(out,f(jj[i,1],jj[i,2],jj[i,3]))
  } 
  return(out)  # out has 64*18432=1179648 elements
}

`every_sign` <- function(a1,a2,a3,a4,a5,r){
 # Function every_sign() has 16 lines; given 5 three-velocities and a
 # scalar, function every_sign() returns a vector of 16*12=192
 # three-velocities [the 12 is from all3()]
  c(
      all3(c(a1 , a2 , +r*gyr(+a3,+a4,+a5))),
      all3(c(a1 , a2 , +r*gyr(+a3,+a4,-a5))),
      all3(c(a1 , a2 , +r*gyr(+a3,-a4,+a5))),
      all3(c(a1 , a2 , +r*gyr(+a3,-a4,-a5))),
      all3(c(a1 , a2 , +r*gyr(-a3,+a4,+a5))),
      all3(c(a1 , a2 , +r*gyr(-a3,+a4,-a5))),
      all3(c(a1 , a2 , +r*gyr(-a3,-a4,+a5))),
      all3(c(a1 , a2 , +r*gyr(-a3,-a4,-a5))),
      all3(c(a1 , a2 , -r*gyr(+a3,+a4,+a5))),
      all3(c(a1 , a2 , -r*gyr(+a3,+a4,-a5))),
      all3(c(a1 , a2 , -r*gyr(+a3,-a4,+a5))),
      all3(c(a1 , a2 , -r*gyr(+a3,-a4,-a5))),
      all3(c(a1 , a2 , -r*gyr(-a3,+a4,+a5))),
      all3(c(a1 , a2 , -r*gyr(-a3,+a4,-a5))),
      all3(c(a1 , a2 , -r*gyr(-a3,-a4,+a5))),
      all3(c(a1 , a2 , -r*gyr(-a3,-a4,-a5)))
  )
}

`all3brack` <- function(x){  # If [abc] = c(x[1],x[2],x[3]), function
                             # all3brack() returns a+(b+c) and (a+b)+c
  c(
      x[1]+(x[2]+x[3])   ,
      (x[1]+x[2])+x[3]
  )
}

`all4brack` <- function(x){
  ## Returns the 5 different ways to bracket 4 objects.  Function
  ## all4vbrack() not currentluy used in this script.
  c(
  (x[1]+x[2])+(x[3]+x[4])   ,
  ((x[1]+x[2])+x[3])+x[4]   ,
  (x[1]+(x[2]+x[3]))+x[4]   ,
  x[1]+((x[2]+x[3])+x[4])   ,
  x[1]+(x[2]+(x[3]+x[4]))
  )
}

`all4` <- function(x){  
 ## Every possible way of combining 4 three-velocities.  Function
 ## all4() is not currently used in this script
  stopifnot(length(x)==4)
  out <- threevel(0)
  jj <- perms(4)
  for(i in seq_len(ncol(jj))){
    out <- c(out,all4brack(x[jj[,i]]))
  }
  return(out)
}

`all3` <- function(x){   # every possible way of combining 3
                         # three-velocities.  Function; if x=c(a,b,c)
                         # with a,b,c three-velocities then all3()
                         # returns a vector of length 2*3!=12

  stopifnot(length(x)==3)
  out <- threevel(0)
  jj <- perms(3)
  for(i in seq_len(ncol(jj))){
    out <- c(out,all3brack(x[jj[,i]]))
  }
  return(out)
}


badness <- prod3(r*(u+v) - possible(u,v,r))  # badness == 0 for perfect law
print(min(badness))

library("hexSticker")

pdf(file="lorentz_icon.pdf",bg="#7733FF")

n <- 2
plot(NA,xlim=c(0,2),ylim=c(0,2),xlab="",ylab="",axes=FALSE,asp=1)

arrows(-2,0,2,0,lwd=5) # x axis
arrows(0,-2,0,2,lwd=5) # t axis

theta <- 0.3
arrows(-2,-2*sin(theta),2,2*sin(theta),lty=2,lwd=5) # x' axis
arrows(-2*sin(theta),-2,2*sin(theta),2,lty=2,lwd=5) # t' axis

arrows(1.9,1.9*sin(theta),2,2*sin(theta),lty=1,lwd=5) # x' axis
arrows(1.9*sin(theta),1.9,2*sin(theta),2,lty=1,lwd=5) # t' axis

segments(-2,-2,-2,2,lwd=5) # leftward-moving null
segments(-2,-2,3,3,lwd=5) # rightward-moving null

x <- seq(from=-1,to=1.9,len=250)
y <- sqrt(1+x^2)

points(x,y,type='l')

points(y,x,type='l')
dev.off()

sticker("lorentz_icon.pdf", package="lorentz", p_size=28, s_x=1, s_y=1.02,
s_width=0.9,asp=sqrt(3)/2, white_around_sticker=TRUE, h_fill="#7733FF",
h_color="#000000", filename="lorentz.png")

## This creates a sequence of pdf diagrams suitable for creating a movie

library("gyrogroup")


sss <- seq(from=1,to=2,len=100)
for(i in seq_along(sss)){
  filename <- paste("~/temp/file",sprintf("%03d",i),".pdf",sep="")

  sol(sss[i])
  u <- as.3vel(c(0.4,0,0))
  v <- seq(as.3vel(c(0.4,-0.2,0)), as.3vel(c(-0.3,0.9,0)),len=20)
  w <- as.3vel(c(0.8,-0.4,0))
  pdf(file=filename)
  comm_fail1(u=u, v=v,bold=17)
  dev.off()
}

# plotting functions called right at the end of this file

library("lorentz")


# following three-velocities closely match those of comm_fail.Rd:
jj <- as.3vel(c(0.4,-0.2,0))
kk <- as.3vel(c(-0.4,0.6,0))
kk1 <- as.3vel(c(-0.4,0.3,0))

u <- as.3vel(c(0.5,0,0))
v <- jj + kk*seq(from=0,to=3,len=28)
w <- as.3vel(c(0.8,-0.4,0))

pdf(file="comm_fail1.pdf")
comm_fail1(u=u, v=v)
dev.off()

pdf(file="comm_fail2.pdf")
comm_fail2(u=u, v=v)
dev.off()

pdf(file="ass_fail.pdf")
ass_fail(
    u=u, 
    v = jj + kk1 * seq(from=0,to=3,len=28),
    w = w, bold=23
)
dev.off()

library("lorentz")
library("sphereplot")



u <- as.3vel(c(0,0,0.8))
v <- r3vel(3000,0.9)
w <- as.3vel(c(0,0.8,0))

n1 <- (u+v)-(v+u)            # noncommutativity
n2 <- (u+(v+w)) - ((u+v)+w)  # nonassociativity



rgl.sphgrid()
rgl.sphpoints(car2sph(v))

rgl.sphgrid()
rgl.sphpoints(car2sph(n1))

rgl.sphgrid()
rgl.sphpoints(car2sph(n2))

% -*- mode: noweb; noweb-default-code-mode: R-mode; -*-
\documentclass[nojss]{jss}
\usepackage{dsfont}
\usepackage{bbm}
\usepackage{amsfonts}
\usepackage{amsmath}
\usepackage{wasysym}
\usepackage{amssymb}
\usepackage{yfonts}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% declarations for jss.cls %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% just as usual
\author{Robin K. S. Hankin\\University of Stirling}
\title{Special relativity in R: introducing the \pkg{lorentz} package}
%\VignetteIndexEntry{The lorentz package}

%% for pretty printing and a nice hypersummary also set:
\Plainauthor{Robin K. S. Hankin}
\Plaintitle{The lorentz package}
\Shorttitle{The lorentz package}

%% an abstract and keywords
\Abstract{ Here I present the \pkg{lorentz} package for working with
  relativistic physics.  The package includes functionality for
  Lorentz transforms and Einsteinian three-velocity addition, which is
  noncommutative and nonassociative.  It is available on CRAN at
  \url{https://CRAN.R-project.org/package=lorentz}.  To cite the
  \pkg{lorentz} package, use \citet{hankin2022_lorentz}.
}

\Keywords{Lorentz transform, Lorentz group, Lorentz law, Lorentz
  velocity addition, special relativity, relativistic physics,
  Einstein velocity addition, Wigner rotation, gyrogroup,
  gyromorphism, gyrocommutative, gyroassociative, four velocity,
  three-velocity, nonassociative, noncommutative}

\Plainkeywords{Lorentz transform, Lorentz group, Lorentz law, Lorentz
  velocity addition, special relativity, relativistic physics,
  Einstein velocity addition, Wigner rotation, gyrogroup,
  gyromorphism, gyrocommutative, gyroassociative, four velocity,
  three-velocity, nonassociative, noncommutative}

  
%% publication information
%% NOTE: This needs to filled out ONLY IF THE PAPER WAS ACCEPTED.
%% If it was not (yet) accepted, leave them commented.
%% \Volume{13}
%% \Issue{9}
%% \Month{September}
%% \Year{2004}
%% \Submitdate{2004-09-29}
%% \Acceptdate{2004-09-29}
%% \Repository{https://github.com/RobinHankin/lorentz} %% this line for Tragula

%% The address of (at least) one author should be given
%% in the following format:
\Address{
  Robin K. S. Hankin\\%\orcid{https://orcid.org/0000-0001-5982-0415}\\
  University of Stirling\\
  E-mail: \email{hankin.robin@gmail.com}
}
%% It is also possible to add a telephone and fax number
%% before the e-mail in the following format:
%% Telephone: +43/1/31336-5053
%% Fax: +43/1/31336-734

%% for those who use Sweave please include the following line (with % symbols):
%% need no \usepackage{Sweave.sty}

%% end of declarations %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\newcommand{\bu}{\mathbf u}
\newcommand{\bv}{\mathbf v}
\newcommand{\bw}{\mathbf w}
\newcommand{\bx}{\mathbf x}
\newcommand{\by}{\mathbf y}

\newcommand{\gyr}[2]{\operatorname{gyr}\left[{\mathbf #1},{\mathbf #2}\right]}

\SweaveOpts{}

\begin{document}


<<echo=FALSE,print=FALSE>>=
library("lorentz")
library("magrittr")
@ 

\hfill\includegraphics[width=1in]{\Sexpr{system.file("help/figures/lorentz.png",package="lorentz")}}

\section{Introduction}

In special relativity, the Lorentz transforms supercede their
classical equivalent, the Galilean transforms~\citep{goldstein1980}.
Lorentz transforms operate on four-vectors such as the four-velocity
or four-potential and are usually operationalised as multiplication by
a $4\times 4$ matrix.  A Lorentz transform takes the components of an
arbitrary four-vector as observed in one coordinate system and returns
the components observed in another system which is moving at constant
velocity with respect to the first.

There are a few existing software tools for working with Lorentz
transforms, mostly developed in an educational context.  Early work
would include that of \citet{horwitz1992} who describe \pkg{relLab}, a
system for building a range of {\em gendanken} experiments in an
interactive graphical environment.  The author asserts that it runs on
``any Macintosh computer with one megabyte of RAM or more'' but it is
not clear whether the software is still available.  More modern
contributions would include the \proglang{OpenRelativity}
toolkit~\citep{sherin2016} which simulates the effects of special
relativity in the \proglang{Unity} game engine.

The \pkg{lorentz} package provides \proglang{R}-centric functionality
for Lorentz transforms.  It deals with formal Lorentz boosts,
converts between three-velocities and four-velocities, and provides
computational support for the gyrogroup structure of relativistic
three-velocity addition.

\section{Lorentz transforms: active and passive}

Passive transforms are the usual type of transforms taught and used in
relativity.  However, sometimes active transforms are needed and it is
easy to confuse the two.  Here I will discuss passive and then active
transforms, and illustrate both in a computational context.

\subsection*{Passive transforms}

\newcommand{\vvec}[2]{\begin{pmatrix}#1 \\ #2\end{pmatrix}}
\newcommand{\twomat}[4]{\begin{pmatrix} #1 & #2 \\ #3 & #4\end{pmatrix}}

Consider the following canonical Lorentz transform in which we have
motion in the $x$-direction at speed $v>0$; the motion is from left to
right.  We consider only the first two components of four-vectors, the
$y$- and $z$- components being trivial.  A typical physical
interpretation is that I am at rest, and my friend is in his spaceship
moving at speed $v$ past me; and we are wondering what vectors which I
measure in my own rest frame look like to him.  The (passive) Lorentz
transform is:

\begin{equation*}
\twomat{\gamma}{-\gamma v}{-\gamma v}{\gamma}
\end{equation*}

And the canonical example of that would be:

\begin{equation*}
\twomat{\gamma}{-\gamma v}{-\gamma v}{\gamma}\vvec{1}{0}=\vvec{\gamma}{-\gamma v}
\end{equation*}

where the vectors are four velocities (recall that $\vvec{1}{0}$ is
the four-velocity of an object at rest).  Operationally, I measure the
four-velocity of an object to be $\vvec{1}{0}$, and he measures the
same object as having a four-velocity of $\vvec{\gamma}{-\gamma v}$.
So I see the object at rest, and he sees it as moving at speed $-v$;
that is, he sees it moving to the left (it moves to the left because
he is moving to the right relative to me).  The package makes
computations easy.  Suppose $v=0.6c$ in the $x$-direction.

<<floater>>=
                          # NB: speed of light = 1 by default
u <- as.3vel(c(0.6,0,0))  # coerce to a three-velocity
u
as.4vel(u)                # four-velocity is better for calculations
(B <- boost(u))           # transformation matrix
@ 

(note that element $[1,2]$ of the boost matrix $B$ is negative as we
have a passive transform).  Then a four-velocity of $(1,0,0,0)^T$
would appear in the moving frame as

<<flighter>>=
B %*% c(1,0,0,0)
@ 

This corresponds to a speed of $-0.75/1.25=-0.6$.  Observe that it is
possible to transform an arbitrary four-vector:

<<flayter>>=
B %*% c(4,6,-8,9)
@ 


\subsubsection*{Null vectors: light}

Let's try it with light (see section~\ref{photonsection} for more
details on photons).  Recall that we describe a photon in terms of its
four momentum, not four-velocity, which is undefined for a photon.
Specifically, we {\em define} the four-momentum of a photon to be

\begin{equation*}
  \left(
  \begin{array}{c}
    E/c\\Ev_x/c^2\\Ev_y/c^2\\Ev_z/c^2
  \end{array}
  \right)
  \end{equation*}

So if we consider unit energy and keep $c=1$ we get $p=\vvec{1}{1}$
in our one-dimensional world (for a rightward-moving photon) and the
Lorentz transform is then

\begin{equation*}
  \twomat{\gamma}{-\gamma v}{-\gamma v}{\gamma}\vvec{1}{1}=\vvec{\gamma-\gamma v}{\gamma-\gamma v}
  \end{equation*}


So, in the language used above, I see a photon with unit energy, and
my friend sees the photon with energy
$\gamma(1-v)=\sqrt{\frac{1-v}{1+v}}<1$, provided that $v>0$: the
photon has less energy in his frame than mine because of Doppler
redshifting.  It's worth doing the same analysis with a
leftward-moving photon:

\begin{equation*}
  \twomat{\gamma}{-\gamma v}{-\gamma v}{\gamma}\vvec{1}{-1}=\vvec{\gamma(1+v)}{-\gamma(1+v)}
  \end{equation*}

Here the photon has more energy for him than me because of blue
shifting: he is moving to the right and encounters a photon moving to
the left.  The R idiom would be

<<flooter>>=
B %*% c(1,1,0,0)
B %*% c(1,-1,0,0)
@ 

for the left- and right- moving photons respectively. 

The above analysis uses {\em passive} transforms: there is a single
physical reality, and we describe that one physical reality using two
different coordinate systems.  One of the coordinate systems uses a
set of axes that are {\em boosted} relative to the axes of the other.

This is why it makes sense to use prime notation as in
$x\longrightarrow x'$ and $t\longrightarrow t'$ for a passive Lorentz
transform: the prime denotes measurements made using coordinates
that are defined with respect to the boosted system, and we see
notation like

\begin{equation*}
\vvec{t'}{x'}=\twomat{\gamma}{-\gamma v}{-\gamma v}{\gamma}\vvec{t}{x}
\end{equation*}  

These are the first two elements of a displacement four-vector.  It is
the same four-vector but viewed in two different reference frames.

\subsection*{Active transforms}

In the passive view, there is a single physical reality, and we are
just describing that one physical reality using two different
coordinate systems.  Now we will consider active transforms: there are
two physical realities, but one is boosted with respect to another.  

Suppose me and my friend have zero relative velocity, but my friend is
in a spaceship and I am outside it, in free space, at rest.  He
constructs a four-vector in his spaceship; for example, he could fire
bullets out of a gun which is fixed in the spaceship, and then
calculate their four-velocity as it appears to him in his
spaceship-centric coordinate system.  We both agree on this
four-velocity as our reference frames are identical: we have no
relative velocity.

Now his spaceship acquires a constant velocity, leaving me stationary.
My friend continues to fire bullets out of his gun and sees that their
four-velocity, as viewed in his spaceship coordinates, is the same as
when we were together.

Now he wonders what the four-velocity of the bullets is in my
reference frame.  This is an {\em active} transform: we have two
distinct physical realities, one in the spaceship when it was at rest
with respect to me, and one in the spaceship when moving.  And both
these realities, by construction, look the same to my friend in the
spaceship.

Suppose, for example, he sees the bullets at rest in his spaceship;
they have a four-velocity of $\vvec{1}{0}$, and my friend says to
himself: ``I see bullets with a four velocity of $\vvec{1}{0}$, and I
know what that means.  The bullets are at rest.  What are the bullets'
four velocities in Robin's reference frame?".  This is an {\em active}
transform:

\begin{equation*}
\twomat{\gamma}{\gamma v}{\gamma v}{\gamma}\vvec{1}{0}=\vvec{\gamma}{\gamma v}
\end{equation*}

(we again suppose that the spaceship moves at speed $v>0$ from left to
right).  So he sees a four velocity of $\vvec{1}{0}$ and I see
$\vvec{\gamma}{\gamma v}$, that is, with a positive speed: the bullets
move from left to right (with the spaceship).  The R idiom would be:

<<>>=
(B <- boost(as.3vel(c(0.8,0,0))))  # 0.8c left to right
solve(B) %*% c(1,0,0,0)            # active transform
@ 

\section{Successive Lorentz transforms}

Coordinate transformation is effected by standard matrix
 multiplication; thus composition of two Lorentz transforms is also
 ordinary matrix multiplication:

<<>>=
u <- as.3vel(c(0.3,-0.4,+0.8))
v <- as.3vel(c(0.4,+0.2,-0.1))
L <- boost(u) %*% boost(v)
L
@ 

But observe that the resulting transform is not a pure boost, as the
spatial components are not symmetrical.  We may decompose the matrix
product $L$ into a pure translation composed with an orthogonal
matrix, which represents a coordinate rotation.  The R idiom is
\code{pureboost()} for the pure boost component, and \code{orthog()}
for the rotation:
             
<<>>=
(P <- pureboost(L))  # pure boost
P - t(P)   # check for symmetry
@              


Now we compute the rotation:
<<>>=
(U <- orthog(L))                  # rotation matrix
U[2:4,2:4]                        # inspect the spatial components
round(crossprod(U) - diag(4),10)  # check for orthogonality
## zero to within numerical uncertainty
@ 

\section[Units in which c is not 1]{Units in which ${\mathbf c\neq 1}$}  

The preceding material used units in which $c=1$.  Here I show how the
package deals with units such as SI in which $c=299792458\neq 1$.  For
obvious reasons we cannot have a function called \code{c()} so the
package gets and sets the speed of light with function \code{sol()}:

<<>>=
sol(299792458)
sol()
@ 

The speed of light is now~$299792458$ until re-set by \code{sol()} (an
empty argument queries the speed of light).  We now consider speeds
which are fast by terrestrial standards but involve only a small
relativistic correction to the Galilean result:
                                                
<<>>=
u <- as.3vel(c(100,200,300))
as.4vel(u)
@ 

The gamma correction term $\gamma$ is only very slightly larger
than~$1$ and indeed R's default print method suppresses the
difference:
                    
<<>>=
gam(u)
@ 

However, we can display more significant figures by subtracting one:

<<>>=
gam(u)-1
@                                                     

or alternatively we can use the \code{gamm1()} function which
calculates $\gamma-1$ more accurately for speeds $\ll c$:
                                                  
<<>>=
gamm1(u)
@                                                   

The Lorentz boost is again calculated by the \code{boost()} function:
              
<<>>=
boost(u)
@ 

The boost matrix is not symmetrical, even though it is a pure boost,
because $c\neq 1$.  


Note how the transform is essentially the Galilean
result, which is discussed below.

\subsection{Changing units}

Often we have a four-vector in SI units and wish to express this in natural units.

<<>>=
sol(299792458)
disp  <- c(1,1,0,0)
@ 

If we interpret \code{disp} as a four-displacement, it corresponds to
moving 1 metre along the x-axis and waiting for one second.  To
convert this to natural units we multiply by the passive
transformation matrix given by \code{ptm()}:

<<>>=
ptm(to_natural=TRUE) %*% disp
@ 

In the above, see how the same vector is expressed in natural units in
which the speed of light is equal to 1: the unit of time is about
$3\times 10^{-9}$ seconds and the unit of distance remains the metre.
Alternatively, we might decide to keep the unit of time equal to one
second, and use a unit of distance equal to 299792458 metres which
again ensures that~$c=1$:

<<>>=
ptm(to_natural=TRUE,change_time=FALSE) %*% disp
@ 

As a further check, we can take two boost matrices corresponding to
the same coordinate transformation but expressed using different units
of length and verify that their orthogonal component agrees:


<<>>=
sol(1)
B1 <- boost((2:4)/10) %*% boost(c(-5,1,3)/10)
orthog(B1)[2:4,2:4]
@ 

Now we create \code{B2} which is the same physical object but using a
length scale of one-tenth of \code{B2} (which requires that we
multiply the speed of light by a factor of 10):

<<>>=
sol(10)
B2 <- boost(2:4) %*% boost(c(-5,1,3))  # exactly the same as B1 above
orthog(B2)[2:4,2:4]
@ 

so the two matrices agree, as expected.


\section{Infinite speed of light}

In the previous section considered speeds that were small compared
with the speed of light and here we will consider the classical limit
of infinite $c$:

<<setcinfinite>>=
sol(Inf)
@ 

Then the familiar parallelogram law operates:

<<parallelograminfinitec>>=
u <- as.3vel(1:3)
v <- as.3vel(c(-6,8,3))
u+v
v+u
@ 

Above we see that composition of velocities is commutative, unlike the
relativistic case.  The boost matrix is instructive:

<<boostinfc>>=
boost(u)
boost(u+v)
boost(u) %*% boost(v)
@ 

Above, see how the boost matrix for the composed velocity of $u+v$
does not have any rotational component, unlike the relativistic case
[recall that \code{boost()} gives a {\em passive} transform, which is
why the sign of the numbers in the first column is changed].  With an
infinite speed of light, even ``large'' speeds have zero relativistic
correction:

<<gamm1google>>=
gamm1(1e100)
@ 

Function \code{rboost()} returns a random Lorentz transform matrix,
which is in general a combination of a pure Lorentz boost and an
orthogonal rotation.  With an infinite speed of light, it requires a
speed:

<<rboostinfc>>=
set.seed(0)
options(digits=3)
(B <- rboost(1))  # random boost, speed 1
@ 

We can decompose \code{B} into a pure boost and an orthogonal
transformation:

<<orthoginfc>>=
orthog(B)
pureboost(B)
@ 


Boost matrices can be applied to any four-vector.  Here I show how
pure spatial displacements transform with an infinite light speed.

<<infinitelightspeedspatialdisplacement>>=
(u <- as.3vel(c(10,0,0))) # velocity of 10, parallel to x axis
(B <- boost(u))
d <- c(0,1,0,0) # displacement of distance one, parallel to the x-axis
B %*% d
@

Above we see that a spatial displacement is the same for both
observers.  We can similarly apply a boost to a temporal displacement:

<<classicalboostspatial>>=
d <- c(1,0,0,0) # displacement of one unit of time, no spatial component
B %*% d
@

Above we see the result expected from classical mechanics.



\section{Vectorization}

Here I discuss vectorized operations (to avoid confusion between boost
matrices and their transposes we will use $c=10$).  The issue is
difficult because a Lorentz boost is conceptually a matrix product of
a $4\times 4$ matrix with vector with four elements:

<<>>=
sol(10)
u <- as.3vel(c(5,-6,4))
(U <- as.4vel(u))
B <- boost(U)
B %*% as.vector(U)
@ 

(note that the result is the four-velocity of an object at rest, as
expected, for we use passive transforms by default).  However, things
are different if we wish to consider many four-vectors in one R
object.  A vector ${\mathbf V}$ of four-velocities is a matrix: each
{\em row} of ${\mathbf V}$ is a four-velocity.  In the package we
represent this with objects of class \code{4vel}.  Because a vector is
treated (almost) as a one-column matrix in R, and the four-velocities
are rows, we need to take a transpose in some sense.

<<>>=
u <- 1:7  # speed in the x-direction [c=10]
jj <- cbind(gam(u),gam(u)*u,0,0)
(U <- as.4vel(jj))
@ 

Now a boost, also in the x-direction:

<<>>=
(B <- boost(as.3vel(c(6,0,0))))  # 60% speed of light
@ 

Note the asymmetry of $B$, in this case reflecting the speed of light
being 10 (but note that boost matrices are not always symmetrical,
even if $c=1$).

To effect a {\em passive} boost we need to multiply each row of $U$ by
the transpose of the boost matrix $B$:

<<>>=
U %*% t(B)
@ 

we can verify that the above is at least plausible:

<<>>=
is.consistent.4vel(U %*% t(B))
@ 

the above shows that the four velocities $U$, as observed by an
observer corresponding to boost $B$, satisfies $U^iU_i=-c^2$.  Anyway,
in this context we really ought to use \code{tcrossprod()}:

<<>>=
tcrossprod(U,B)
@ 

which would be preferable (because this idiom does not require one to
take a transpose) although the speed increase is unlikely to matter
much because $B$ is only $4\times 4$.

The above transforms were passive: we have some four-vectors measured
in my rest frame, and we want to see what these are four-vectors as
measured by my friend, who is moving in the positive x direction at
60\% of the speed of light (remember that $c=10$).  See how the
x-component of the transformed four-velocity is negative, because in
my friend's rest frame, the four velocities are pointing backwards.

To effect an {\em active} transform we need to take the matrix inverse
of $B$:

<<>>=
solve(B)
@ 

and then

<<>>=
tcrossprod(U,solve(B))
@ 

In the above, note how the positive x-component of the four-velocity
is increased because we have actively boosted it.  We had better check
the result for consistency:

<<>>=
is.consistent.4vel(tcrossprod(U,solve(B)))
@ 

\section{Multiple boosts}


If we are considering multiple boosts, it is important to put them in
the correct order.  First we will do some passive boosts.

<<>>=
sol(100)
B1 <- boost(r3vel(1)) %*% boost(r3vel(1))
B2 <- boost(r3vel(1)) %*% boost(r3vel(1)) 
(U <- r4vel(5))
@

Successive boosts are effected by matrix multiplication; there are at
least four equivalent R constructions:

<<>>=
U %*% t(B1) %*% t(B2)
U %*% t(B2 %*% B1)    # note order of operations
tcrossprod(U, B2 %*% B1)
U %>% tcrossprod(B2 %*% B1)
@ 

(in the above, note that the result is the same in each case).

\subsection*{A warning}

It is easy to misapply matrix multiplication in this context.  Note
carefully that the following natural idiom is {\bf incorrect}:

<<>>=
U %*% B  # Young Frankenstein: Do Not Use This Brain!
## The above idiom is incorrect.  See
## https://www.youtube.com/watch?v=m7-bMBuVmHo&t=1s
## (in particular @1:08) for a technical explanation of why 
## this is a Very Bad Idea (tm).
@ 

It is not clear to me that the idiom above has any meaning at all.

\section{The stress-energy tensor}

The stress-energy tensor (sometimes the energy-momentum tensor) is a
generalization and combination of the classical concepts of density,
energy flux, and the classical stress tensor~\citep{schutz1985}.  It
is a contravariant tensor of rank two, usually represented as a
symmetric $4\times 4$ matrix.  The \pkg{lorentz} package includes
functionality for applying Lorentz transforms to the stress energy
tensor.

<<>>=
sol(1)        # revert to natural units 
D <- dust(1)  # Dust is the simplest nontrivial SET, with 
D             # only one nonzero component
@ 

The stress-energy tensor is usually written with two upstairs
(contravariant) indices, as in~$T^{\alpha\beta}$; it may be
transformed using the \code{transform_uu()} function: 

<<>>=
B <- boost(as.3vel(c(0.0,0.8,0.0)))
transform_uu(D,B)
@ 

In this reference frame, the dust is not at rest: the stress-energy
tensor has components corresponding to nonzero pressure and momentum
transfer, and the $[t,t]$ component is greater, at 2.78, than its rest
value of 1.  Note that the $[t,y]$ component is negative as we use
passive transforms.  If one wants to consider the stress-energy tensor
with downstairs indices (here we will use a photon gas), we need to
use \code{transform_dd()}:

<<>>=
pg <- photongas(3)
pg
transform_uu(pg,B)
@

again we see that the $[0,0]$ component is larger than its rest value,
and we see nonzero off-diagonal components which correspond to the
dynamical behaviour.  As a consistency check we can verify that this
is the same as transforming the SET with upstairs indices, using the
\code{lower()} and \code{raise()} functions:

<<>>=
raise(transform_dd(lower(pg),lower(B)))
raise(transform_dd(lower(pg),lower(B))) - transform_uu(pg,B) #zero to numerical precision
@ 

One of the calls to \code{lower()} is redundant; for a photon gas,
raising or lowering both indices does not change the components as the
Minkowski metric is symmetric and orthogonal.

\subsection{Successive boosts}
  
Successive boots are represented as ordinary matrix multiplication.
Again the \pkg{magrittr} package can be used for more readable idiom.
 
<<>>=
B1 <- boost(as.3vel(c(0.5,-0.4,0.6)))
B2 <- boost(as.3vel(c(0.1,-0.1,0.3)))
pf <- perfectfluid(4,1)
pf
pf %>% transform_uu(B1) %>% transform_uu(B2)
pf %>% transform_uu(B2 %*% B1)  # should match
@                                                            

Again as a consistency check, we may verify that transforming
downstairs indices gives the same result:

<<>>=
lower(pf) %>% transform_dd(lower(B1) %*% lower(B2)) %>% raise()
@ 

(note that the matrix representation of the Lorentz transforms
requires that the order of multiplication be reversed for successive
covariant transforms, so \code{B1} and \code{B2} must be swapped).

\subsection{Speed of light and the stress-energy tensor}

Here I will perform another consistency check, this time with non-unit
speed of light, for a perfect fluid:

<<>>=
sol(10)
pf_rest <- perfectfluid(1,4)
pf_rest
@ 

Thus \code{pf_rest} is the stress energy for a perfect fluid at rest
in a particular frame $F$.  We may now consider the same perfect
fluid, but moving with a three velocity of~$(3,4,5)'$: with respect to
$F$:

<<>>=
u <- as.3vel(3:5)
pf_moving <- perfectfluid(1,4,u)
pf_moving
@ 

The consistency check is to verify that transforming to a frame in
which the fluid is at rest will result in a stress-energy tensor that
matches \code{pf_rest}:

<<>>=
transform_uu(perfectfluid(1,4,u),boost(u))
@ 

thus showing agreement to within numerical precision.

\section{Photons}
\label{photonsection}
It is possible to define the four-momentum of photons by specifying
their three-velocity and energy, and using \code{as.photon()}:
 
<<>>=
sol(1)
(A <- as.photon(as.3vel(cbind(0.9,1:5/40,5:1/40))))
@ 

above, $A$ is a vector of four-momentum of five photons, all of unit
energy, each with a null world line.  They are all moving
approximately parallel to the x-axis.  We can check that this is
indeed a null vector:
                                                 
<<>>=
inner4(A)
@                                                  

showing that the vectors are indeed null to numerical precision.  What
do these photons look like in a frame moving along the $x$-axis at
$0.7c$?
  
<<>>=
tcrossprod(A,boost(as.3vel(c(0.7,0,0))))
@   

Above, see how the photons have lost the majority of their energy due
to redshifting.  Blue shifting is easy to implement as either a
passive transform:
                                            
<<>>=
tcrossprod(A,boost(as.3vel(c(-0.7,0,0))))
@   
                  
or an active transform:

<<>>=
tcrossprod(A,solve(boost(as.3vel(c(0.7,0,0)))))
@   

giving the same result.


\subsection{Reflection in mirrors}

\citet{gjurchinovski2004} discusses reflection of light from a
uniformly moving mirror and here I show how the \pkg{lorentz} package
can illustrate some of his insights.  We are going to take the five
photons defined above and reflect them in an oblique mirror which is
itself moving at half the speed of light along the $x$-axis.  The
first step is to define the mirror \code{m}, and the boost \code{B}
corresponding to its velocity:
                                                              
<<>>=
m <- c(1,1,1)
B <- boost(as.3vel(c(0.5,0,0)))
@ 

Above, the three-vector $m$ is parallel to the normal vector of the
mirror and $B$ shows the Lorentz boost needed to bring it to rest.  We
are going to reflect these photons in this mirror.  The R idiom for
the reflection is performed using a sequence of transforms.  First,
transform the photons' four-momentum to a frame in which the mirror is
at rest:

<<>>=
A
(A <- as.4mom(A %*% t(B)))
@ 

Above, see how the photons have lost energy because of a redshift (the
\code{as.4mom()} function has no effect other than changing the column
names).  Next, reflect the photons in the mirror (which is at rest):

<<>>=
(A <- reflect(A,m))
@ 

Above, see how the reflected photons have a reduced the x-component of
momentum; but have acquired a substantial $y$- and $z$- component.
Finally, we transform back to the original reference frame.  Observe
that this requires an {\em active} transform which means that we need
to use the matrix inverse of $B$:

<<>>=
(A <- as.4mom(A %*% solve(t(B))))
@ 

Thus in the original frame, the photons have lost about a quarter of
their energy as a result of a Doppler effect: the mirror was receding
from the source.  The photons have imparted energy to the mirror as a
result of mechanical work.  It is possible to carry out the same
operations in one line:

<<>>=
A <- as.photon(as.3vel(cbind(0.9,1:5/40,5:1/40)))
A %>% tcrossprod(B) %>% reflect(m) %>% tcrossprod(solve(B)) %>% as.4mom
@ 

\subsection{Disco ball}

It is easy to define a disco ball, which is a sphere covered in
mirrors.  For the purposes of exposition, we will use a rather shabby
ball with only 7 mirrors:

<<disco_ball>>=
dfun <- function(n){matrix(rnorm(n*3),ncol=3) %>% sweep(1, sqrt(rowSums(.^2)),`/`)}
(disco <- dfun(7))
@ 

Then we define a unit-energy photon moving parallel to the x-axis, and
reflect it in the disco ball:

<<>>=
p <- as.photon(c(1,0,0))
reflect(p,disco)
@ 

(above, \code{p} is a photon moving along the x-axis; standard R
recycling rules imply that we effectively have one photon per mirror
in \code{disco}.  See how the photons' energy is unchanged by the
reflection).  We might ask what percentage of photons are reflected
towards the source; but to do this we would need a somewhat more
stylish disco ball, here with 1000 mirrors:

<<disco_reflect_percentage>>=
table(reflect(p,dfun(1000))[,2]>0) # should be TRUE with probability sqrt(0.5)
@ 

(compare the expected value of $1000/\sqrt{2}\simeq 707$).  But it is
perhaps more fun to consider a relativistic disco in which the mirror
ball moves at 0.5c:


<<relativistic_disco>>=
B <- boost(as.3vel(c(0.5,0,0)))
p %>% tcrossprod(B) %>% reflect(disco) %>% tcrossprod(solve(B))
@ 

Above, note the high energy of the photon in the third row.  This is
because the third mirror of \code{disco} is such that the photon hits
it with grazing incidence; this means that the receding of the mirror
is almost immaterial.  Note further that a spinning disco ball would
give the same (instantaneous) results.

\subsection{Mirrors and rotation-boost coupling}

Consider the following situation: we take a bunch of photons which in
a certain reference frame are all moving (almost) parallel to the
$x$-axis.  Then we reflect the photons from a mirror which is moving
with a composition of pure boosts, and examine the reflected light in
their original reference frame.  The R idiom for this would be:

<<>>=
sol(1)
light_start <- as.photon(as.3vel(cbind(0.9,1:5/40,5:1/40)))
m <- c(1,0,0)     # mirror normal to x-axis
B1 <- boost(as.3vel(c(-0.5, 0.1, 0.0)))
B2 <- boost(as.3vel(c( 0.2, 0.0, 0.0)))
B3 <- boost(as.3vel(c( 0.0, 0.0, 0.6)))
B <- B1 %*% B2 %*% B3   # matrix multiplication is associative!
light <- light_start %*% t(B)
light <- reflect(light,m)
light <- as.4mom(light %*% solve(t(B)))
light
@ 

See how the photons have picked up momentum in the $y$- and $z$-
direction, even though the mirror is oriented perpendicular to the
$x$-axis (in its own frame).  Again it is arguably preferable to use
pipes:

<<>>=
light_start %>% tcrossprod(B) %>% reflect(m) %>% tcrossprod(solve(B)) %>% as.4mom
@ 

Compare when the speed of light is infinite:
<<>>=
sol(Inf)
light_start <- as.photon(as.3vel(cbind(0.9,1:5/40,5:1/40)))
B1 <- boost(as.3vel(c(-0.5, 0.1, 0.0)))
B2 <- boost(as.3vel(c( 0.2, 0.0, 0.0)))
B3 <- boost(as.3vel(c( 0.0, 0.0, 0.6)))
B <- B1 %*% B2 %*% B3
light_start
light_start %>% tcrossprod(B) %>% reflect(m) %>% tcrossprod(solve(B)) %>% as.4mom
@ 

Note that, in the infinite light speed case, the energy of the photons
is zero (photons have zero rest mass); further observe that in this
classical case, the effect of the mirror is to multiply the $x$-momentum
by $-1$ and leave the other components unchanged, as one might expect
from a mirror perpendicular to $(1,0,0)$.

\section{Three-velocities}

In contrast to four-velocities, three-velocities do not form a group
under composition as the velocity addition law is not
associative~\citep{ungar2006}.  Instead, three-velocity composition
has an algebraic structure known as a {\em gyrogroup} (this
observation was the original motivation for the package).
\citeauthor{ungar2006} shows that the velocity addition law for
three-velocities is

\begin{equation}
\bu\oplus\bv=
\frac{1}{1+\bu\cdot\bv}
\left\{
\bu + \frac{\bv}{\gamma_\bu} + \frac{\gamma_\bu
\left(\bu\cdot\bv\right)\bu}{1+\gamma_\bu}
\right\}
\end{equation}
   
where~$\gamma_\bu=\left(1-\bu\cdot\bu\right)^{-1/2}$ and we are
assuming~$c=1$.  \citeauthor{ungar2006} goes on to show that, in
general, $\bu\oplus\bv\neq\bv\oplus\bu$
and~$(\bu\oplus\bv)\oplus\bw\neq\bu\oplus(\bv\oplus\bw)$.  He also
defines the binary operator~$\ominus$
as~$\bu\ominus\bv=\bu\oplus\left(-\bv\right)$, and implicitly
defines~$\ominus\bu\oplus\bv$ to be~$\left(-\bu\right)\oplus\bv$.  If
we have

\begin{equation}
\gyr{u}{v}\bx=-\left(\bu\oplus\bv\right)\oplus\left(\bu\oplus\left(\bv\oplus\bx\right)\right)
\end{equation}

then

\begin{eqnarray}
\bu\oplus\bv &=& \gyr{u}{v}\left(\bv\oplus\bu\right)\label{noncom}\\
\gyr{u}{v}\bx\cdot\gyr{u}{v}\by &=& \bx\cdot\by\label{doteq}\\
\gyr{u}{v}\left(\bx\oplus\by\right) &=& \gyr{u}{v}\bx\oplus\gyr{u}{v}\by\\
\left(\gyr{u}{v}\right)^{-1} &=& \left(\gyr{v}{u}\right)\label{gyrinv}\\
\bu\oplus\left(\bv\oplus\bw\right) &=&\left(\bu\oplus\bv\right)\oplus\gyr{u}{v}\bw\label{nonass1}\\
\left(\bu\oplus\bv\right)\oplus\bw &=&\bu\oplus\left(\bv\oplus\gyr{v}{u}\bw\right)\label{nonass2}
\end{eqnarray}

Consider the following R session:

<<kickoff>>=
sol(1)
u <- as.3vel(c(-0.7,+0.2,-0.3))
v <- as.3vel(c(+0.3,+0.3,+0.4))
w <- as.3vel(c(+0.1,+0.3,+0.8))
x <- as.3vel(c(-0.2,-0.1,-0.9))
u
@ 

Here we have three-vectors \code{u} etc.  We can see that \code{u} and
\code{v} do not commute:

<<try>>=
u+v
v+u
@ 

(the results differ).  We can use equation~\ref{noncom}
<<>>=
(u+v)-gyr(u,v,v+u)
@ 

showing agreement to within numerical error.  It is also possible to
use the functional idiom in which we define \code{f()} to be the
map~$\bx\mapsto\gyr{u}{v}\bx$.  In R:

<<funcid>>=
f <- gyrfun(u,v)
(u+v)-f(v+u)    # should be zero
@ 

Function \code{gyrfun()} is vectorized, which means that it plays
nicely with (R) vectors.  Consider

<<vec9>>=
u9 <- r3vel(9)
u9
@ 

Then we can create a vectorized gyrofunction:

<<vecfun>>=
f <- gyrfun(u9,v)
f(x)
@ 

Note that the package vectorization is transparent when using syntactic sugar:

<<u9+x>>=
u9+x
@ 

(here, the addition operates using R's standard recycling rules).

\subsection{Associativity}

Three velocity addition is not associative:

<<nonass>>=
(u+v)+w
u+(v+w)
@ 

But we can use equations~\ref{nonass1} and~\ref{nonass2}:

<<nonass1>>=
(u+(v+w)) - ((u+v)+gyr(u,v,w))
((u+v)+w) - (u+(v+gyr(v,u,w)))
@ 

\subsection{Visualization of noncommutativity and nonassociativity of three-velocities}

Consider the following three-velocities:

<<viss>>=
u <- as.3vel(c(0.4,0,0))
v <- seq(as.3vel(c(0.4,-0.2,0)), as.3vel(c(-0.3,0.9,0)),len=20)
w <- as.3vel(c(0.8,-0.4,0))
@ 

Objects~$\bv$ and $\bw$ are single three-velocities, and object $\bv$
is a vector of three velocities.  We can see the noncommutativity of
three velocity addition in figures~\ref{comfail1} and~\ref{comfail2},
and the nonassociativity in figure~\ref{assfail}.

\begin{figure}[htbp]
  \begin{center}
<<comfail1_fig, fig=TRUE>>=
comm_fail1(u=u, v=v)
@
\caption{Failure\label{comfail1} of the commutative law for velocity
  composition in special relativity.  The arrows show successive
  velocity boosts of $+\bu$ (purple), $+\bv$ (black), $-\bu$ (red),
  and~$-\bv$ (blue) for $\bu,\bv$ as defined above.  Velocity $\bu$ is
  constant, while $\bv$ takes a sequence of values.  If velocity
  addition is commutative, the four boosts form a closed
  quadrilateral; the thick arrows show a case where the boosts almost
  close and the boosts nearly form a parallelogram.  The blue dots
  show the final velocity after four successive boosts; the distance
  of the blue dot from the origin measures the combined velocity,
  equal to zero in the classical limit of low speeds.  The discrepancy
  becomes larger and larger for the faster elements of the sequence
  $\bv$}
  \end{center}
\end{figure}

\begin{figure}[htbp]
  \begin{center}
<<comfail2_fig, fig=TRUE>>=
comm_fail2(u=u, v=v)
@

\caption{Another view of the failure of the commutative
  law\label{comfail2} in special relativity.  The black arrows show
  velocity boosts of $\bu$ and the blue arrows show velocity boosts of
  $\bv$, with $\bu,\bv$ as defined above; $\bu$ is constant while
  $\bv$ takes a sequence of values.  If velocity addition is
  commutative, then $\bu+\bv=\bv+\bu$ and the two paths end at the
  same point: the parallelogram is closed.  The red lines show the
  difference between $\bu+\bv$ and $\bv+\bu$}
  \end{center}
\end{figure}

\begin{figure}[htbp]
  \begin{center}
<<assfail_fig, fig=TRUE>>=
ass_fail(u=u, v=v, w=w, bold=10)
@
\caption{Failure of the associative law \label{assfail} for velocity
  composition in special relativity.  The arrows show successive
  boosts of $\bu$ followed by $\bv+\bw$ (black lines), and $\bu+\bv$
  followed by $\bw$ (blue lines), for $\bu$, $\bv$, $\bw$ as defined
  above; $\bu$ and $\bw$ are constant while $\bv$ takes a sequence of
  values. The mismatch between $\bu+\left(\bv+\bw\right)$ and
  $\left(\bu+\bv\right)+\bw$ is shown in red}
  \end{center}
\end{figure}


\subsection[The magrittr package: pipes]{The \pkg{magrittr} package: pipes}

Three velocities in the \pkg{lorentz} package work nicely with
\pkg{magrittr}.  If we define

<<defuvw>>=
 u <- as.3vel(c(+0.5,0.1,-0.2))
 v <- as.3vel(c(+0.4,0.3,-0.2))
 w <- as.3vel(c(-0.3,0.2,+0.2))
@ 

Then pipe notation operates as expected:

<<>>=
jj1 <- u %>% add(v)
jj2 <- u+v
speed(jj1-jj2)
@ 

The pipe operator is left associative:

<<>>=
jj1 <- u %>% add(v) %>% add(w)
jj2 <- (u+v)+w
speed(jj1-jj2)
@ 


If we want right associative addition, the pipe operator needs
brackets:

<<>>=
jj1 <- u %>% add(v %>% add(w))
jj2 <- u+(v+w)
speed(jj1-jj2)
@ 

\subsection{Numerical verification}

Here I provide numerical verification of equations~\ref{noncom}
to~\ref{nonass2}.  If we have

<<funcnotation>>=
x <- as.3vel(c(0.7, 0.0, -0.7))
y <- as.3vel(c(0.1, 0.3, -0.6))
u <- as.3vel(c(0.0, 0.8, +0.1))   # x,y,u: single three-velocities
v <- r3vel(5,0.9)
w <- r3vel(5,0.8)                 # v,w: vector of three-velocities
f <- gyrfun(u,v)
g <- gyrfun(v,u)
@

Then we can calculate the difference between the left hand side and
right hand side numerically:
  
<<testeq3to8>>=
max(speed((u+v) - f(v+u)))              # equation 3
max(abs(prod3(f(x),f(y)) - prod3(x,y))) # equation 4
max(speed(f(x+y) - (f(x)+f(y))))        # equation 5
max(speed(f(g(x)) - g(f(x))))           # equation 6
max(speed((u+(v+w)) - ((u+v)+f(w))))    # equation 7
max(speed(((u+v)+w) - (u+(v+g(w)))))    # equation 8
@ 

(all zero to numerical precision). 


\section{Conclusions}

The \pkg{lorentz} package furnishes some functionality for
manipulating four-vectors and three-velocities in the context of
special relativity.  The R idiom is relatively natural and the package
has been used to illustrate different features of relativistic
kinematics.

\bibliography{lorentz}
\end{document}
 

---
title: "Vectors on the unit disk: Möbius addition"
author: "Robin K. S. Hankin"
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{Mobius addition}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<p style="text-align: right;">
![](`r system.file("help/figures/lorentz.png", package = "lorentz")`){width=10%}
</p>

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

We define Möbius addition $\oplus$ on the unit disk $\mathbb{D} =
\left\lbrace z\in\mathbb{C}\colon\left|z\right|<1\right\rbrace$ as
follows:

\begin{equation}
a\oplus z = \frac{a+z}{1+\overline{a}z}
\end{equation}

(naturally we define $a\ominus z=a\oplus(-z)$ and it convenient to
write $\ominus z=0\ominus z=-z$).  Observe that $0\oplus z=z\oplus
0=z$, and $z\ominus z=(-z)\oplus z=0$.



The $\oplus$ operator is neither commutative nor associative ($a\oplus
b\neq b\oplus a$ and $a\oplus(b\oplus c)\neq (a\oplus b)\oplus c$ in
general).  However, it does possess the _automorphic inverse property_

\begin{equation}
\ominus(a\oplus b) = \ominus a\ominus b
\end{equation}

and the _left cancellation law_

\begin{equation}
\ominus a\oplus (a\oplus z) = z
\end{equation}


proof:
\[
\ominus(a\oplus b) = -(a\oplus b)=-\frac{a+b}{1+\overline{a}b}
=\frac{(-a)+(-b)}{1+\overline{a}b}
=\frac{(-a)+(-b)}{1+\overline{(-a)}(-b)}
=(-a)\oplus(-b)
=\ominus a\ominus b
\]

\[
\ominus a\oplus (a\oplus z) = 
\ominus a\oplus\frac{a+z}{1+\overline{a}z}
=\frac{-a + \frac{a+z}{1+\overline{a}z}}{1+\overline{(-a)}\frac{a+z}{1+\overline{a}z}}
=\frac{-a\overline{a}z +z}{1-\overline{a}a}
=\frac{z(1-a\overline{a})}{1-\overline{a}a}
=z,
\]

the last equality following from the fact that $a\in\mathbb{D}$.
Observe that, in general, $(a\oplus b)\ominus a \neq b$ and $\ominus
a\oplus (z\oplus a)\neq z$, so one must use the left cancellation law
with care.


```{r}

`%+%` <- function(x,y){(x+y)/(1+Conj(x)*y)}
`%-%` <- function(x,y){(x-y)/(1-Conj(x)*y)}

square <- function(a,b,len=100){ # a is lower left point, b is upper right
    a <- a+0i
    b <- b+0i
    c(
    seq(from=Re(a) + 1i*Im(a), to=Re(b) + 1i*Im(a),len=len),
    seq(from=Re(b) + 1i*Im(a), to=Re(b) + 1i*Im(b),len=len),
    seq(from=Re(b) + 1i*Im(b), to=Re(a) + 1i*Im(b),len=len),
    seq(from=Re(a) + 1i*Im(b), to=Re(a) + 1i*Im(a),len=len)
    )
}

gyrosetup <- function(...){
	par(pty="s")
	plot(NA,xlim=c(-1,1),ylim=c(-1,1),asp=1,axes=FALSE,xlab="",ylab="")
theta <- seq(from=0,to=2*pi,len=400)
points(sin(theta),cos(theta),type="l",col="gray",...)
segments(x0=-1, x1= +1,y0=0,col='gray')
segments(x0=0,y0=-1,y1=+1,col='gray')
text(0.9,0.06,"Re")
text(0.1,0.9,"Im")
}

polyz <- function(z,...){polygon(x=Re(z),y=Im(z),...)}

gyrosetup()

S <- square(-1-1i,1+1i)/6
points(S,type="l")

zs <- c(
    +0.2 + 0.38i,
    -0.2 + 0.58i,
    +0.2 - 0.38i,
    -0.3 - 0.38i
)*1.4

for(z in zs){
points(Re(z),Im(z))
polyz(S %+% z,col=rgb(1,0,0,alpha=0.3))
polyz(z %+% S,col=rgb(0,0,1,alpha=0.3))
}

```

---
title: 'Special relativity in R: the ``lorentz`` package '
authors:
- affiliation: 1
  name: Robin K. S. Hankin
  orcid: 0000-0001-5982-0415
date: "September 05, 2019"
output: pdf_document
bibliography: ref.bib
tags:
- special relativity
- Lorentz transform
- Lorentz boosts
- Three velocity
- Four velocity
affiliations:
- index: 1
  name: University of Stirling
---

# Introduction: the Lorentz transform in special relativity

In special relativity [@einstein1905], the Lorentz transforms
[@lorentz1904] supercede their classical equivalent, the Galilean
transforms.  Lorentz transforms operate on four-vectors such as the
four-velocity or four-potential and are usually operationalised as
multiplication by a $4\times 4$ matrix.  A Lorentz transform takes the
components of an arbitrary four-vector as observed in one coordinate
system and returns the components observed in another system which is
moving at constant velocity with respect to the first.

# Statement of need

Einstein's theory of special relativity presents specific difficulties
for its teaching and learning [@prado2020].  One particularly
problematic concept is that of four velocity, defined as the
deriviative of an object's four-displacement with respect to its
proper time [@resnick1968].  Students are often left puzzled as to why
an object with three degrees of freedom is described using an object
with four components.  Observing (correctly) that the familiar
classical velocity addition law is incorrect for both three-velocities
and four-velocities in relativistic mechanics, students may reasonably
ask in what way four-velocities are preferable to three-velocities.

The `lorentz` package [@hankin2022_lorentz] furnishes a consistent
suite of computational functionality to give numerical illustration of
many concepts of special relativity, including manipulation of three-
and four- velocities.  It is accessible to undergraduates, being
written in the `R` programming language [@rcore2022] which will be
familiar to many physics students.  The package allows the user to
manipulate Lorentz boosts using familiar matrix multiplication, and in
addition incorporates in an efficient and consistent interface to deal
with many aspects of undergraduate-level relativity including active
and passive transforms, four-mometum of photons, and in particular the
difficult and nonintuitive behaviour of units in which $c\neq 1$ [such
as S. I.].  The classical limit of $c=\infty$ is discussed explicitly
and computationally.  The package allows the user to employ efficient
and natural vectorised R idiom in the context of relativistic
kinematics.

The package was originally written to facilitate investigation into
the nonassociative and noncommutative "gyrogroup" structure of
three-velocities [@ungar1997]; but the pedagogical impact of this is
to reinforce the primacy of four-vectors in relativity.  One student,
using the package, succinctly offers the observation that
``three-velocities suck": surely a profound insight.

# Previous related work

There are a few existing software tools for working with Lorentz
transforms, mostly developed in an educational context.  Early work
would include that of Horwitz et al. [-@horwitz1992], who describe
``relLab``, a system for building a range of *gendanken* experiments
in an interactive graphical environment.  The author asserts that it
runs on "any Macintosh computer with one megabyte of RAM or more" but
it is not clear whether the software is still available.  More modern
contributions would include the ``OpenRelativity`` toolkit
[@sherin2016] which simulates the effects of special relativity in the
``Unity`` game engine.  There are also many excellent github repos
that provide functionality to create simple visual displays of Lorentz
transforms of events (eg
```https://github.com/nick1627/RelativityVisualisation```) although
these are generally restricted to a single spatial dimension.

Educational models (in the sense of @possel2018) for Einstein's
general theory of relativity [@einstein1907] tend to be physical
[@possel2018]; but software examples would include the present
author's software [@hankin2021] for visualizing black holes and
gravitational radiation.

# The ``lorentz`` package: summary of high-level functionality

The ``lorentz`` package provides ``R``-centric functionality for
Lorentz transforms.  It deals with formal Lorentz boosts and converts
between three-velocities and four-velocities.  Computational support
for the nonassociative and noncommutative gyrogroup structure of
relativistic three-velocity addition is included.  Some functionality
for relativistic transformation of tensors of order two such as the
stress-energy tensor is given, with examples.  In the package, the
speed of light is one by default, but is user-settable and the
classical limit is recovered by setting $c=\infty$.  Both passive and
active transforms are implemented.  An extensive heuristic vignette
detailing package idiom is included.  There does not seem to be a
known relativistic generalization of the classical distributive law
$r\left({\bf u} + {\bf v}\right)=r{\bf u} + r{\bf v}$ [@ungar1997].
Ungar states that ``It is hoped that one day a gyrodistributive law
$\ldots$ will be discovered.  If exists, it is expected to be the
standard distributive law relaxed by Thomas gyration in some
unexpected way''.  The package is used to execute a systematic sweep
through possible distributive laws consistent with Ungar's suggestion,
unfortunately without success.

# References

---
title: "The headlight effect in special relativity: a numerical illustration"
author: "Robin K. S. Hankin"
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{the headlight effect}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

<p style="text-align: right;">
![](`r system.file("help/figures/lorentz.png", package = "lorentz")`){width=10%}
</p>


```{r setup, include=FALSE}
set.seed(0)
knitr::opts_chunk$set(echo = TRUE)
library("lorentz")
library("magrittr")
options("digits" = 5)
```

<p style="text-align: right;">
![](`r system.file("help/figures/lorentz.png", package = "lorentz")`){width=10%}
</p>

In special relativity, the _headlight effect_ (also known as
_relativistic beaming_ and _light aberration_) occurs when a source of
light moves relative to an observer.  Rays of light from the source
which reach the observer are tilted towards the direction of the
source's motion (relative to the observer).  It is as if light emitted
by a moving object is concentrated towards its direction of motion.
Also, light received by a moving object (e.g. the view from a very
fast spacecraft) also appears concentrated towards its direction of
motion; see the
[wikipedia](https://en.wikipedia.org/wiki/Relativistic_aberration)
entry.

First we will create 10 photons emitted from a stationary object, in
random directions:

```{r readcurlingtable}
p1 <- as.photon(r3vel(n=10))
p1
```

See how they all have unit energy (column 1).  We can calculate the photons' angle with respect the
the $x$-axis:

```{r}
angle <- function(P){acos(P[,2]/sqrt(rowSums(P[,-1]^2)))}
angle(p1)
summary(angle(p1))
```

and we see that the angles are reasonably uniformly distributed on the
interval $[0,\pi)$.  But now suppose these photons are emitted from an
object moving at say $0.7c$ along the $x$-axis.  This is most easily
effected by a passive Lorentz transform

```{r}
B <- boost(c(-0.7,0,0))
p2 <- p1 %>% tcrossprod(B)
p2
```

above we see that the photons' energy has changed---as one might expect
from Doppler shifting.  Although most photons have increased their
energy, some have decreased: this is because they were emitted
backwards compared with the path of the object.  Photon number 4, for
example, was emitted almost exactly along the (negative) $x$-axis and
this photon has about half its energy in the transformed frame.
What angle do the photons make with the x-axis?

```{r}
angle(p2)
summary(angle(p2))
```

we see that the mean angle changes from about 1.4 to about 0.8:
relativistic aberration of light.  The effect may be illustrated
more dramatically using a larger number of photons.


```{r,unshiftedphotons,fig.cap="Distribution of angles made by photons from a uniform source at rest"}
p1 <- as.photon(r3vel(n=10000))
hist(angle(p1))

```{r,shiftedphotons,fig.cap="Distribution of angles made by photons from a uniform source moving at 0.7c"}
p2 <- p1 %>% tcrossprod(B)
hist(angle(p2))
```

Figures \@ref(fig:unshiftedphotons) and \@ref(fig:shiftedphotons)
show that the photons have a smaller angle in the shifted frame
than the unshifted frame.  This may be illustrated by plotting one
angle against the other:

```{r,onagainstother,fig.cap="scattergraph of angles with x-axis for photons in the unshifted frame against angles in the shifted frame"}
par(pty='s')
plot(angle(p1),angle(p2),asp=1,xlim=c(0,pi),ylim=c(0,pi))
abline(0,1,col='gray')
```

```{r,photonsandenergy,fig.cap="Photons emitted from a stationary object (black lines) and an object moving at $0.7c$ to the right (red).  Lengths of lines correspond to photon energy and angles to the projected angle measured in the two reference frames.  Irregularity in red lines' lengths is due to the suppressed third dimension"}
par(pty='s')
plot(NA,xlim=c(-1.5,3),ylim=c(-1,1),asp=1,xlab="x",ylab="y")
p1[,4] <- 0
p2[,4] <- 0
for(i in seq_len(100)){
   segments(x0=0,y0=0,x1=p1[i,1]*cos(angle(p1)[i]),y1=p1[i,1]*sin(angle(p1)[i])*sign(p1[i,3]),col='black')
   segments(x0=0,y0=0,x1=p2[i,1]*cos(angle(p2)[i]),y1=p2[i,1]*sin(angle(p2)[i])*sign(p2[i,3]),col='red'  )
}
```
